static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xAC, 0x5B, 0x8F, 0x0E, 0x77, 0x12, 0x4D, 0x44, 0xD5, 0x78,
        0x88, 0x38, 0xDD, 0x9F, 0x6B, 0xE5, 0x8D, 0x03, 0xF3, 0x23,
        0x70, 0xA5, 0x7C, 0x1A, 0xEC, 0x45, 0x2F, 0x1F, 0xD4, 0xB2,
        0xDD, 0x68, 0xD7, 0xC0, 0xD5, 0xB5, 0xBF, 0x8D, 0x65, 0x97,
        0x36, 0xE7, 0xF7, 0x19, 0x9F, 0x3A, 0xF6, 0xCF, 0x4B, 0x4B,
        0x07, 0x1B, 0x8A, 0xF2, 0xDA, 0x78, 0x97, 0x68, 0x12, 0x78,
        0xF5, 0xB1, 0x84, 0x1B
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
static DH *get_dh2048(void)
{
    static unsigned char dhp_2048[] = {
        0xD3, 0x94, 0x6C, 0xEE, 0x26, 0xCF, 0xCC, 0xA5, 0x62, 0xE0,
        0x40, 0xE5, 0xCA, 0xD7, 0xB4, 0xE2, 0xF2, 0x8F, 0xCD, 0x3B,
        0x3C, 0x14, 0xD8, 0x1D, 0x70, 0x2E, 0x4F, 0xDD, 0x09, 0x72,
        0xBB, 0x1F, 0x76, 0x75, 0x4F, 0x07, 0x61, 0x31, 0x52, 0xD9,
        0x5D, 0xBF, 0x2B, 0x6D, 0xDE, 0x60, 0x48, 0xFB, 0x1B, 0xDC,
        0xD8, 0x74, 0x8D, 0x09, 0x64, 0x25, 0x1F, 0xA3, 0x95, 0x01,
        0x6A, 0x1F, 0xE8, 0x78, 0xCA, 0x10, 0x16, 0xE6, 0x28, 0xE0,
        0xB7, 0xF2, 0x1C, 0xC5, 0xAB, 0x63, 0xBF, 0xEC, 0x3B, 0xAD,
        0x94, 0xC8, 0x4E, 0x6C, 0xA4, 0xCC, 0x77, 0xAE, 0x9A, 0xF3,
        0xC7, 0x96, 0x0B, 0xAF, 0x02, 0xD6, 0x42, 0xA1, 0xDA, 0x37,
        0x40, 0xEA, 0x5D, 0xCE, 0xE0, 0x5A, 0x2D, 0x58, 0x76, 0xCB,
        0xCF, 0xE1, 0x1F, 0xF3, 0x9C, 0xF7, 0xD1, 0x49, 0x19, 0x7A,
        0xBF, 0xFB, 0x71, 0x7D, 0x3B, 0x44, 0x0C, 0x00, 0x5C, 0x5D,
        0x91, 0x95, 0x2E, 0xE9, 0x2D, 0x63, 0x60, 0x2A, 0xFB, 0x6F,
        0x4A, 0xCF, 0xA1, 0xBF, 0x7F, 0x0D, 0x37, 0x8C, 0x47, 0x29,
        0x7E, 0xDB, 0x78, 0x57, 0xEA, 0x38, 0x33, 0xBD, 0xA5, 0xA0,
        0x87, 0xCF, 0x5A, 0x61, 0x2F, 0x5D, 0x58, 0x75, 0x4F, 0x71,
        0x7C, 0x0B, 0x39, 0xAE, 0xAA, 0x26, 0xC5, 0xEE, 0x44, 0xF6,
        0xB1, 0x68, 0x4F, 0xE5, 0xFE, 0x7C, 0x64, 0xF9, 0xCA, 0x8C,
        0x29, 0xDD, 0x22, 0x07, 0x52, 0x4D, 0x0D, 0x19, 0xF8, 0x10,
        0x9B, 0x13, 0x96, 0x6C, 0x2B, 0xF2, 0xB7, 0x2A, 0x2C, 0xBA,
        0x55, 0x13, 0x40, 0x83, 0x14, 0x1B, 0x7B, 0xC9, 0x42, 0xAF,
        0xBE, 0xB1, 0xDB, 0x45, 0xD4, 0x2C, 0x3A, 0x16, 0x32, 0xCD,
        0x6B, 0x50, 0x8E, 0xBD, 0x5D, 0xAD, 0x4C, 0x65, 0xB6, 0x7D,
        0x1E, 0x4C, 0x00, 0x3F, 0x97, 0xAA, 0xA5, 0xE1, 0xA5, 0x71,
        0xA6, 0xE3, 0x3D, 0x3E, 0xE0, 0x53
    };
    static unsigned char dhg_2048[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_2048, sizeof(dhp_2048), NULL);
    g = BN_bin2bn(dhg_2048, sizeof(dhg_2048), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
